#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, k, x;
    cin >> n >> k >> x;
    vector<int> a = vector<int>(n, -1);

    if (k == 3) {
        // 21 poen
        if (n < 3) {
            cout << "-1";
            return 0;
        } else if (n == 3) {
            for (int i = 0; i < n; i++) {
                a[i] = (x * i) + 1;
            }
        } else {
            int middle = x / 2 + 1;
            for (int i = 0; i < n; i++) {
                if (i == 0)
                    a[i] = 1;
                else {
                    if (i <= k)
                        a[i] = (x + 1);
                    else {
                        a[i] = middle;
                    }
                }
            }
        }
    } else if (k == n) {
        int middle = x / 2 + 1;
        int counter = 0;
        bool oof = false;
        if (n % 2 == 0) {
            for (int i = 0; i < n; i++) {
                if (i <= 1)
                    a[i] = 1;
                else {
                    if (counter++ < n / 2) {
                        a[i] = x + 1;
                    } else {
                        a[i] = middle;
                    }
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                if (i <= 1)
                    a[i] = i + 1;
                else {
                    if (counter++ < n / 2) {
                        a[i] = (x + 2);
                    } else {
                        if (!oof) {
                            oof = true;
                            a[i] = (x + 1);
                        } else
                            a[i] = middle;
                    }
                }
            }
        }
    } else {
        int num = x + 1;
        int counter = 0;

        if (n == 1 && k == 0) {
            cout << (x + 1);
            return 0;
        }
        if (n == 1 && k == 1) {
            cout << x;
            return 0;
        }

        for (int i = 0; i < n; i++) {
            if (i == 0)
                a[i] = 1;
            else {
                if (counter++ < k)
                    a[i] = num;
                else {
                    int middle = (1 + x) / 2;

                    if (middle - 1 >= x || x - middle >= x) {
                        cout << "-1";
                        return 0;
                    }

                    a[i] = middle;
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        cout << a[i] << ' ';
    }

    return 0;
}